
# Precise Placement

Re-upload of a mod from nexus mods for easier addition to my mod pack.  All credit goes to that original author Koosemose.  Original mod page is located at https://www.nexusmods.com/valheim/mods/1544.


## Description
Allows rotation around any Axis using modifier keys (Around X default: Left Shift, Around Z default: Left Ctrl, Around Y: no modifier)

## Manual Movement
Manual Movement with keys: Lock the piece you are building in place (default: L), and then use the arrow keys to move piece around. Piece can also be moved up and down (default: PgUp & PgDn). Once built the piece still has normal placement requirements (so while you can build something floating in the air, it will immediately break since it has no structural support).

Pieces can be moved in steps of 1 meter, .5 meters, .1 meters or .05 meters (default keys in order: no modifier, Left Ctrl, Left Shift, Left Alt). Step sizes other than the base 1 meter are now configurable, and despite being referred to as Small, Smaller, and Smallest in the config file, they don't have to actually be smaller, you could have one set to 10 meters, if you want to move things long distance.

Note that pieces will still snap to other pieces if the Snap Points are close enough, so it may not look like a piece is moving if this is the case, as normal holding shift before placing will allow you to place in an unsnapped position (and if you're moving a piece in an area that multiple positions are snapping, you may have to periodically press Shift to see the piece's real unsnapped position).

Placement of pieces is based on where your character is standing (for purposes of nearby crafting stations) and where you are looking at, this means to place a piece you need to be looking at something that can be built on (a wall, floor, or the ground primarily). This does allow some interesting placement, such as looking at the water, and moving a Ship manually so you can place it on land, or even on top of your house (Since ships still require water, it won't be going very far).

## Rotation
By default, pieces rotate in place (as normally when placing a piece by mouse), but this can be turned off so that rotation in the Y axis (normal rotation axis) but this can be toggled off (default: Left Ctrl + backquote (Backquote being the key that is to the left of the one and also has the tilde (~) on standard American keyboards)), so that Y rotation will be around the lock point (the point where you Pressed L to lock in place) during manual movement, while this normally makes rotating a manually moved piece more awkward, it can be useful for particular things (mainly when you want to place multiple things in a circle around a common point).

## Piece Projection
Projection mode can help with placement when manually moving a locked piece by either projecting it down to the ground, or the piece below your placement marker. Toggle (default P) between no projection, Terrain Projection, and Piece Projection (if no pieces below placement marker, will instead project onto the ground. Piece Projection can be very useful if you want to manually move something but want it placed along a floor or a shelf.

## Gimbal Locking
Gimbal locking can now be disabled (Gimbal locking is when a piece is rotated in a certain way, and a certain direction of rotation becomes unavailable due to how rotation is calculated). This is off by default (I find that rotation feels less natural when gimbal locking is disabled, due to the different calculations), but can easily be turned off or on as you prefer.

## Copy Piece Rotation and Position
Copy targeted Piece's Rotation and Position (if current piece isn't locked, position will be immediately changed based on mouse position just as normal), default Ctrl+C. Particularly useful in situations where you have something placed that doesn't have snap points previously but want to add new things aligned to it, such as placing evenly space banks of chests or lines of torches, or just use the rotation copy (copy with unlocked piece) to save time matching rotation. Note: pieces like slanted roofs don't have rotation, or in other words their normal slant is no rotation, so copying from a slanted roof will give you something placed flat like normal).

## Compatibility
Now has ValheimRAFT compatibility, pieces will place as expected on the raft, and even manual movement works as you might want (placement is based on what you have targeted, so you need to be looking at the raft in manual movement mode, else placement will not align properly.

## Further Notes
Note: With latest version of Jotunn, configs can be set in game from the Mod Setting menu, particularly useful for switching back and forth between gimbal locking modes, if one or the other works better for a particular placement. 

If you get to mixed up where your piece is and how it's rotated, you can reset rotation and position (default: backquote).
By default rotation and manual movement works with the hammer (and if you have Planbuild the blueprint rune), but other tools can be added to the Tool Whitelist in the config file (note: manual movement doesn't work well with tools like the cultivator, since those typically want to be place on the ground, and manual movement keeps the same Y level (up/down placement))
Rotation should support controllers now.

And finally if you have another mod that handles rotation or manual movement of a piece that you would prefer to use, but still won't the other part of this mod, rotation or manual movement can be separately turned off or on in config.

